diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index cb66b9133..f11708a46 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -14,7 +14,7 @@ public class BlockColorWater extends BlockColorCustom {
 	
 	@Override
 	public int getFallbackColor(int meta) {
-		if(!mc.gameSettings.biomeWater.value) {
+		if(!mc.gameSettings.biomeWater.value || (mc.currentWorld != null && mc.currentWorld.isRetro())) {
 			return 0xFFFFFFFF;
 		}
 		return super.getFallbackColor(meta);
@@ -22,7 +22,7 @@ public class BlockColorWater extends BlockColorCustom {
 	
 	@Override
 	public int getWorldColor(WorldSource world, int x, int y, int z) {
-		if(!mc.gameSettings.biomeWater.value) {
+		if(!mc.gameSettings.biomeWater.value || world.isRetro()) {
 			return 0xFFFFFFFF;
 		}
 		return super.getWorldColor(world, x, y, z);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index e21074ca7..03c18b0ff 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -14,7 +15,6 @@ public abstract class BlockModel<T extends BlockLogic>
 {
     public static RenderBlocks renderBlocks;
     public final Block<T> block;
-    protected boolean hasOverbright = false;
     public BlockModel(Block<T> block){
         this.block = block;
     }
@@ -54,7 +54,10 @@ public abstract class BlockModel<T extends BlockLogic>
         return block.getBounds();
     }
     public boolean hasOverbright(){
-        return hasOverbright;
+        return false;
+    }
+    public boolean isRetro() {
+        return Minecraft.getMinecraft().currentWorld != null && Minecraft.getMinecraft().currentWorld.isRetro();
     }
     // Everything below is utility
     public static void setRenderBlocks(RenderBlocks rb)
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
index a7b9dfd7b..6ce62dc91 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
@@ -16,16 +16,14 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
         TextureRegistry.getTexture("minecraft:block/activator/side_active"),
         TextureRegistry.getTexture("minecraft:block/activator/side_active")
     };
-    public final IconCoordinate[] overbrightTextures = {
-        TextureRegistry.getTexture("minecraft:block/activator/bottom_active_overlay"),
-        TextureRegistry.getTexture("minecraft:block/activator/top_active_overlay"),
-        TextureRegistry.getTexture("minecraft:block/activator/side_active_overlay"),
-        TextureRegistry.getTexture("minecraft:block/activator/front_active_overlay"),
-        TextureRegistry.getTexture("minecraft:block/activator/side_active_overlay"),
-        TextureRegistry.getTexture("minecraft:block/activator/side_active_overlay")
-    };
+
     public BlockModelActivator(Block<T> block) {
         super(block);
+        overbrightTextures
+            .set("minecraft:block/activator/bottom_active_overlay", Side.BOTTOM)
+            .set("minecraft:block/activator/top_active_overlay", Side.TOP)
+            .set("minecraft:block/activator/front_active_overlay", Side.SOUTH)
+            .set("minecraft:block/activator/side_active_overlay", Side.WEST, Side.EAST, Side.NORTH);
     }
 
     @Override
@@ -37,7 +35,7 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if ((data & BlockLogicActivator.MASK_POWERED) != 0) {
-            return poweredTextures[getTextureIndex(side, data)];
+            return poweredTextures[getRotatedSide(side, data).getId()];
         } else {
             return super.getBlockTextureFromSideAndMetadata(side, data);
         }
@@ -48,6 +46,6 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
     {
         boolean isPowered = (data & BlockLogicActivator.MASK_POWERED) != 0;
         if (!isPowered) return null;
-        return overbrightTextures[getTextureIndex(side, data)];
+        return super.getBlockOverbrightTextureFromSideAndMeta(side, data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index 94842cfef..4770216a6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -50,7 +50,7 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if ((6 * (data & 3) + side.getId()) >= Sides.orientationLookUpXYZAligned.length) return TextureRegistry.getTexture("minecraft:block/grass_top");
-        return atlasIndices[Sides.orientationLookUpXYZAligned[6 * (data & 3) + side.getId()]];
+        return super.getBlockTextureFromSideAndMetadata(Side.getSideById(Sides.orientationLookUpXYZAligned[6 * (data & 3) + side.getId()]), data);
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index 7cccfe222..3976bc5cf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -11,14 +11,16 @@ import net.minecraft.core.util.phys.AABB;
 
 public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate underTexture = TextureRegistry.getTexture("minecraft:block/bed/bottom");
+    protected final IconCoordinate[] bedTextures = new IconCoordinate[6];
+
     public BlockModelBed(Block<T> block) {
         super(block);
-        atlasIndices[0] = TextureRegistry.getTexture("minecraft:block/bed/foot_front");
-        atlasIndices[1] = TextureRegistry.getTexture("minecraft:block/bed/foot_side");
-        atlasIndices[2] = TextureRegistry.getTexture("minecraft:block/bed/foot_top");
-        atlasIndices[3] = TextureRegistry.getTexture("minecraft:block/bed/head_front");
-        atlasIndices[4] = TextureRegistry.getTexture("minecraft:block/bed/head_side");
-        atlasIndices[5] = TextureRegistry.getTexture("minecraft:block/bed/head_top");
+        bedTextures[0] = TextureRegistry.getTexture("minecraft:block/bed/foot_front");
+        bedTextures[1] = TextureRegistry.getTexture("minecraft:block/bed/foot_side");
+        bedTextures[2] = TextureRegistry.getTexture("minecraft:block/bed/foot_top");
+        bedTextures[3] = TextureRegistry.getTexture("minecraft:block/bed/head_front");
+        bedTextures[4] = TextureRegistry.getTexture("minecraft:block/bed/head_side");
+        bedTextures[5] = TextureRegistry.getTexture("minecraft:block/bed/head_top");
     }
 
     @Override
@@ -93,21 +95,21 @@ public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
         int l = BlockLogicBed.bedDirection[k][side.getId()];
         if(BlockLogicBed.isBlockFootOfBed(data)) {
             if(l == 2) {
-                return atlasIndices[3];
+                return bedTextures[3];
             }
             if(l == 5 || l == 4) {
-                return atlasIndices[4];
+                return bedTextures[4];
             } else {
-                return atlasIndices[5];
+                return bedTextures[5];
             }
         }
         if(l == 3) {
-            return atlasIndices[0];
+            return bedTextures[0];
         }
         if(l == 5 || l == 4) {
-            return atlasIndices[1];
+            return bedTextures[1];
         } else {
-            return atlasIndices[2];
+            return bedTextures[2];
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
index aab08a3ed..47b31a82d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
@@ -21,9 +21,7 @@ public class BlockModelCake<T extends BlockLogic> extends BlockModelStandard<T>
         if(data > 0 && side == Side.WEST)
         {
             return cakeInner;
-        } else
-        {
-            return atlasIndices[side.getId()];
         }
+        return super.getBlockTextureFromSideAndMetadata(side, data);
     }
 }
